svn commit: r339850 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Mon Oct 29 09:06:21 UTC 2018


Author: pho
Date: Mon Oct 29 09:06:20 2018
New Revision: 339850
URL: https://svnweb.freebsd.org/changeset/base/339850

Log:
  Added a new unmount test scenario.
  
  Sponsored by:	Dell EMC Isilon

Added:
  user/pho/stress2/misc/umount3.sh   (contents, props changed)

Added: user/pho/stress2/misc/umount3.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/umount3.sh	Mon Oct 29 09:06:20 2018	(r339850)
@@ -0,0 +1,68 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2018 Dell EMC Isilon
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Parallel unmount of the same mount point with one mounter thread and 4
+# threads doing unmount.
+
+# "panic: dounmount: invalid lock refcount in the drain path @
+# ../../../kern/vfs_mount.c:1409" seen in WiP code.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+parallel=4
+continue=/tmp/umount3.cont
+touch $continue
+
+[ -c /dev/md$mdstart ] && mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 10m -u $mdstart || exit 1
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+
+for i in `jot $parallel`; do
+	while [ -f $continue ]; do umount $mntpoint; done 2>/dev/null &
+done
+
+start=`date '+%s'`
+while [ $((`date '+%s'` - start)) -lt 300 ]; do
+	mount | grep -q "on $mntpoint " ||
+	    mount /dev/md${mdstart}$part $mntpoint
+done > /dev/null 2>&1
+rm $continue
+wait
+
+while mount | grep $mntpoint | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+mdconfig -d -u $mdstart
+exit 0


More information about the svn-src-user mailing list